<?php
///////////////////////////////////////////////////////////////////////////

define('YOUTUBE_API_URL',   'http://gdata.youtube.com/feeds/api');
define('YOUTUBE_DEV_KEY',   'AI39si5RF9ZM16mBFTZgPNLIeQYlZ-q55H-hf2NjnK04-e4WlYJCE5RWc3navWgw6ZRmQudpvmQqnV9fthtqvwzw9i-gQezi2g');
define('YOUTUBE_PAGE_SIZE', '4');

///////////////////////////////////////////////////////////////////////////

class Youtube
{
    public static function get_watch_url($id)
    {
        return "http://www.youtube.com/watch?v=$id";
    }

    ///////////////////////////////////////////////////////////////////////

    public static function retrieve_playback_url($id, &$plugin_cookies)
    {
        // hack! but it seems to be helpfull, no more plugin restarts
        set_time_limit(0);
        $video_quality = 'medium';//isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 'hd1080';
        switch ($plugin_cookies->video_quality)
        {
        case 4:
            $video_quality = 'hd1080';
            break;
        case 3:
            $video_quality = 'hd720';
            break;
        }
        $mp4 = 'http-mp4';//isset($plugin_cookies->mp4) ? $plugin_cookies->mp4 : 'http-mp4';

        $doc =
                HD::http_get_document(
                        Youtube::get_watch_url($id),
                        array(
                            CURLOPT_FOLLOWLOCATION => true,
                            CURLOPT_MAXREDIRS => 10,
                            CURLOPT_HEADER => true,
                            CURLOPT_HTTPHEADER => array('X-GData-Key', YOUTUBE_DEV_KEY),
                ));
        //hd_print("----- doc: $doc");
        hd_print("--> Retrieving playback URL for $id...");

        if (preg_match("/yt.playerConfig = ({.*});/", $doc, $m) !== 1)
        {
            hd_print("--> Can't find playerConfig.");
            //hd_print("----- doc: $doc");

            if (preg_match("/\"fmt_url_map\":/", $doc, $m) === 1)
                hd_print("==> FOUND fmt_url_map !!!!!");

            return false;
        }

        $cfg = json_decode($m[1]);

        $str = $cfg->args->url_encoded_fmt_stream_map;
        $lst = explode(',', $str);

        $first_found = "";
        $last_found = "";
        $first_quality = "";
        $last_quality = "";

        foreach ($lst as $l)
        {
            $str = urldecode($l);
            //hd_print("--- str: $str");
            if (preg_match('/url=(http:\/\/.*)&type=video\/mp4/', $str, $url) === 1) {
                if ($mp4 === 'http-mp4')
                {
                    $playback_url = str_replace('http://', 'http://mp4://', $url[1]);
                }
                else
                {
                    $playback_url = $url[1];
                }
                hd_print("--- playback_url: $playback_url");

                $this_video_quality = '';
                if (preg_match('/&quality=([^&]+)&/', $playback_url, $quality) === 1) {
                    $this_video_quality = $quality[1];
                }

                if ($first_found === "") {
                    $first_found = $playback_url;
                    $first_quality = $this_video_quality;
                }
                $last_found = $playback_url;
                $last_quality = $this_video_quality;

                //hd_print("--> video: $id; playback url: '$playback_url'");
                hd_print("--> video: $id; mp4-stream found, quality: $this_video_quality");
                if (($this_video_quality === $video_quality) || (($this_video_quality !== 'medium') && ($video_quality === 'hdonly'))) {
                    hd_print("-----> returned qaulity as requested: $video_quality");
                    return $playback_url;
                }
            }
        }

        if (($last_found !== "") && ($video_quality !== 'hdonly')) {
            if ($video_quality === 'hd1080') {
                hd_print("-----> returned qaulity $first_quality instead of requested: $video_quality");
                return $first_found;
            } else {
                hd_print("-----> returned qaulity $last_quality instead of requested: $video_quality");
                return $last_found;
            }
        } else {
            // hd_print("--> video: $id; playback url: ''");
            hd_print("--> video: $id; no mp4-stream.");
            return false;
        }
    }

}

///////////////////////////////////////////////////////////////////////////
?>
